'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.SessionDataAdapter = exports.NoStoreSessionSource = exports.NiSessionSource = exports.SecuritySessionSourceDecorator = exports.CookieSessionSource = exports.ConstSessionSource = exports.ASessionSource = exports.SessionDataManager = exports.SessionDataManagerFactory = exports.CreateID = exports.User = exports.SessionData = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _gcl = require('gcl');

var _gcl2 = _interopRequireDefault(_gcl);

var _zlib = require('zlib');

var _zlib2 = _interopRequireDefault(_zlib);

var _config = require('gcl/com/coooders/io/config');

var _config2 = _interopRequireDefault(_config);

var _cookie = require('gcl/com/coooders/net/cookie');

var _cookie2 = _interopRequireDefault(_cookie);

var _mime = require('gcl/com/coooders/net/mime');

var _ni = require('gcl/com/coooders/db/ni');

var _ni2 = _interopRequireDefault(_ni);

var _querystring = require('querystring');

var _querystring2 = _interopRequireDefault(_querystring);

var _nodeXlsx = require('node-xlsx');

var _nodeXlsx2 = _interopRequireDefault(_nodeXlsx);

var _ws = require('ws');

var _ws2 = _interopRequireDefault(_ws);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * session:VESH V层会话管理器删除会话信息
 */
var SessionData = exports.SessionData = function () {
    function SessionData(id, name) {
        (0, _classCallCheck3.default)(this, SessionData);

        var _pri = pri(this, {
            name: name,
            idic: {},
            isClear: false,
            isClearCache: false,
            id: id,
            manager: null
        }),
            _ = _pri._,
            __ = _pri.__;
    }

    (0, _createClass3.default)(SessionData, [{
        key: 'clear',
        value: function clear() {
            var _pri2 = pri(this),
                _ = _pri2._,
                __ = _pri2.__;

            __.isClear = true;
            __.idic = {};
        }
    }, {
        key: 'clearCache',
        value: function clearCache() {
            var _pri3 = pri(this),
                _ = _pri3._,
                __ = _pri3.__;

            __.isClearCache = true;
        }
    }, {
        key: 'data',
        value: function data(k, v) {
            var _pri4 = pri(this),
                _ = _pri4._,
                __ = _pri4.__;

            if (typeof v != 'undefined') __.idic[k] = v;else return __.idic[k];
        }
    }, {
        key: 'remove',
        value: function remove(k) {
            var _pri5 = pri(this),
                _ = _pri5._,
                __ = _pri5.__;

            delete __.idic[k];
        }
    }, {
        key: 'serialize',
        value: function serialize() {
            var _pri6 = pri(this),
                _ = _pri6._,
                __ = _pri6.__;

            return _gcl2.default.merge({}, __.idic);
        }
    }, {
        key: 'toString',
        value: function toString() {
            return _gcl2.default.toJsonString(this.serialize());
        }
    }, {
        key: 'deserialize',
        value: function deserialize(data, clear) {
            var _pri7 = pri(this),
                _ = _pri7._,
                __ = _pri7.__;

            if (clear) __.idic = {};
            if (data && data.split) {
                var _data = _querystring2.default.parse(data);
                for (var i in _data) {
                    if (typeof _data[i] != 'function') __.idic[i] = _data[i];
                }
            } else if ((typeof data === 'undefined' ? 'undefined' : (0, _typeof3.default)(data)) == 'object') _gcl2.default.merge(__.idic, data, true);
            return;
        }
    }, {
        key: 'dispose',
        value: function dispose() {
            clear();
        }
    }, {
        key: 'SessionID',
        get: function get() {
            var _pri8 = pri(this),
                _ = _pri8._,
                __ = _pri8.__;

            return __.id;
        },
        set: function set(id) {
            var _pri9 = pri(this),
                _ = _pri9._,
                __ = _pri9.__;

            if (__.id && __.id != id) throw new Error('SessionID 只能设置一次');
            __.id = id;
        }
    }, {
        key: 'Name',
        get: function get() {
            var _pri10 = pri(this),
                _ = _pri10._,
                __ = _pri10.__;

            return __.name;
        }
    }, {
        key: 'IsClear',
        get: function get() {
            var _pri11 = pri(this),
                _ = _pri11._,
                __ = _pri11.__;

            return __.isClear;
        }
    }, {
        key: 'IsClearCache',
        get: function get() {
            var _pri12 = pri(this),
                _ = _pri12._,
                __ = _pri12.__;

            return __.isClearCache;
        }
    }, {
        key: 'Manager',
        get: function get() {
            var _pri13 = pri(this),
                _ = _pri13._,
                __ = _pri13.__;

            return __.manager;
        },
        set: function set(sdm) {
            var _pri14 = pri(this),
                _ = _pri14._,
                __ = _pri14.__;

            if (__.manager) throw new Error('manager 只能设置一次');
            __.manager = sdm;;
        }
    }]);
    return SessionData;
}();
var User = exports.User = function (_SessionData) {
    (0, _inherits3.default)(User, _SessionData);

    function User() {
        (0, _classCallCheck3.default)(this, User);
        return (0, _possibleConstructorReturn3.default)(this, (User.__proto__ || (0, _getPrototypeOf2.default)(User)).call(this, null, '.User'));
    }

    (0, _createClass3.default)(User, [{
        key: 'serialize',
        value: function serialize() {
            var _pri15 = pri(this),
                _ = _pri15._,
                __ = _pri15.__,
                id = (0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'SessionID', this);

            if (!_gcl2.default.isValid(id)) throw new Error('必须定义SessionID');
            if (_.Login) {
                if (!_gcl2.default.isValid(_.UserID)) throw new Error('必须定义UserID');
                this.LoginTime = new Date();
            }
            var ret = (0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'serialize', this).call(this);
            if (this.LoginTime) ret['LT'] = this.LoginTime.getTime();
            ret['.ID'] = id;
            return ret;
        }
    }, {
        key: 'deserialize',
        value: function deserialize(data, clear) {
            var _pri16 = pri(this),
                _ = _pri16._,
                __ = _pri16.__;

            (0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'deserialize', this).call(this, data, clear);
            if (this.LoginTime) this.LoginTime = new Date(parseInt(this.LoginTime));
            if ((0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'data', this).call(this, '.ID') && _.SessionID && _.SessionID != _.data('.ID')) throw new Error('SessionID 不同！不能重复设置！');else _.SessionID = (0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'data', this).call(this, '.ID');
            _.remove('.ID');
        }
    }, {
        key: 'toString',
        value: function () {
            var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
                var _pri17, _, __, ret;

                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                _pri17 = pri(this), _ = _pri17._, __ = _pri17.__;
                                ret = this.serialize();

                                delete ret['.ID'];
                                delete ret['UID'];
                                delete ret['SID'];
                                delete ret['EID'];
                                delete ret['LT'];
                                delete ret['lin'];
                                ret.UserID = this.UserID;
                                ret.SessionID = this.SessionID;
                                ret.EntityID = this.EntityID;
                                ret.SystemID = this.SystemID;
                                ret.LoginTime = this.LoginTime;
                                ret.Login = this.Login;

                                if (!_.Manager) {
                                    _context.next = 27;
                                    break;
                                }

                                _context.next = 17;
                                return _.Manager.EIDS.get();

                            case 17:
                                ret.EIDS = _context.sent;
                                _context.next = 20;
                                return _.Manager.MEIDS.get();

                            case 20:
                                ret.MEIDS = _context.sent;
                                _context.next = 23;
                                return _.Manager.Permission.get();

                            case 23:
                                ret.PIDS = _context.sent;
                                _context.next = 26;
                                return _.Manager.MENUS.get();

                            case 26:
                                ret.MENUS = _context.sent;

                            case 27:
                                return _context.abrupt('return', _gcl2.default.toJsonString(ret));

                            case 28:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function toString() {
                return _ref.apply(this, arguments);
            }

            return toString;
        }()
    }, {
        key: 'Login',
        get: function get() {
            return (0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'data', this).call(this, "lin") == 1;
        },
        set: function set(v) {
            var _pri18 = pri(this),
                _ = _pri18._,
                __ = _pri18.__;

            if (v != this.Login) {
                (0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'data', this).call(this, 'lin', v ? 1 : 0);
                if (v) _.LoginTime = new Date();else {
                    (0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'clear', this).call(this);
                    _.Manager.EIDS.clear();
                    _.Manager.MEIDS.clear();
                    _.Manager.MENUS.clear();
                    _.Manager.Permission.clear();
                }
            }
        }
    }, {
        key: 'UserID',
        get: function get() {
            return (0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'data', this).call(this, "UID");
        },
        set: function set(v) {
            (0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'data', this).call(this, 'UID', v);
        }
    }, {
        key: 'SystemID',
        get: function get() {
            return (0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'data', this).call(this, 'SID');
        },
        set: function set(v) {
            (0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'data', this).call(this, 'SID', v);
        }
    }, {
        key: 'EntityID',
        get: function get() {
            return (0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'data', this).call(this, 'EID');
        },
        set: function set(v) {
            (0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'data', this).call(this, 'EID', v);
        }
    }, {
        key: 'LoginTime',
        get: function get() {
            return (0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'data', this).call(this, 'LT');
        },
        set: function set(v) {
            (0, _get3.default)(User.prototype.__proto__ || (0, _getPrototypeOf2.default)(User.prototype), 'data', this).call(this, 'LT', v);
        }
    }]);
    return User;
}(SessionData);
var CreateID = exports.CreateID = function CreateID() {
    return _gcl2.default.hash(_gcl2.default.random());
};
var SessionDataManagerFactory = exports.SessionDataManagerFactory = function () {
    function SessionDataManagerFactory(adapter, security, language) {
        (0, _classCallCheck3.default)(this, SessionDataManagerFactory);

        pri(this, { adapter: adapter, security: security, language: language });
    }

    (0, _createClass3.default)(SessionDataManagerFactory, [{
        key: 'getValue',
        value: function getValue() {
            var _pri19 = pri(this),
                _ = _pri19._,
                __ = _pri19.__;

            return new SessionDataManager(__.adapter, __.security, __.language);
        }
    }, {
        key: 'setValue',
        value: function setValue(sdm) {
            if (sdm && sdm.dispose) sdm.dispose();
        }
    }]);
    return SessionDataManagerFactory;
}();
/**
 * SessionDataManager:会话管理 每次请求都会新建一个会话管理用于管理这个会话上下文,改造为prototype模式以方面快速new
 */
var SessionDataManager = exports.SessionDataManager = function () {
    function SessionDataManager(adapter, passtime, language) {
        var _this2 = this;

        (0, _classCallCheck3.default)(this, SessionDataManager);

        this.testRequired = function (key, error) {
            _gcl2.default.testRequired(_this2.param(key), error || '\u9650\u5236' + key + '\u8981\u6C42\u4E3A\u5FC5\u586B');
            return _this2.param(key);
        };

        this.testRequired = function (key, error) {
            _gcl2.default.testRequired(_this2.param(key), error || '\u9650\u5236' + key + '\u8981\u6C42\u4E3A\u5FC5\u586B');
            return _this2.param(key);
        };

        var _pri20 = pri(this, {
            adapter: adapter,
            passtime: passtime || 8,
            lang: language,
            idic: {},
            user: new User(),
            end: false,
            sb: _gcl2.default.sb(),
            streams: []
        }),
            _ = _pri20._,
            __ = _pri20.__;

        __.user.Manager = _;
        this.status = "";
        this.encoding = "UTF-8";
    }

    /**
     * 最重要的属性 用于决定是否结束moduler链的处理
     */


    (0, _createClass3.default)(SessionDataManager, [{
        key: 'end',
        value: function end(statusCode, desc) {
            var _pri21 = pri(this),
                _ = _pri21._,
                __ = _pri21.__;

            __.end = true;
            if (__.interrupt) {
                desc && (this.status = desc);
                return;
            }
            this.Response.statusCode = statusCode;
            if (desc) _.write(desc, null, true);
        }
    }, {
        key: 'redirect',


        /**
         * @param {重定向URL} url 
         */
        value: function redirect(url) {
            var _pri22 = pri(this),
                _ = _pri22._,
                __ = _pri22.__;

            __.end = true;
            if (__.interrupt) return;
            this.Response.statusCode = 302;
            this.Response.setHeader('Location', url);
        }

        /**
         * 
         * @param {gcl config对象} config 
         * @param {gcl middler对象} middler 
         * @param {gcl log对象} log 
         * @param {gcl ni对象} ni 
         * @param {node req对象} req 
         * @param {node rep对象} rep 
         */

    }, {
        key: 'init',
        value: function init(config, middler, log, ni, req, rep, wsSessionIdic) {
            var _pri23 = pri(this, { config: config, middler: middler, log: log, ni: ni, req: req, rep: rep, wsSessionIdic: wsSessionIdic }),
                _ = _pri23._,
                __ = _pri23.__;
        }

        /**
         * 重新初始化会话纤细
         * @param {会话ID} sessionID 
         */

    }, {
        key: 'reInit',
        value: function reInit(sessionID) {
            var _pri24 = pri(this),
                _ = _pri24._,
                __ = _pri24.__;

            for (var k in __) {
                switch (k) {
                    case 'adapter':
                    case 'config':
                    case 'middler':
                    case 'log':
                    case 'ni':
                    case 'req':
                    case 'rep':
                    case 'lang':
                    case 'passtime':
                        break;
                    default:
                        delete __[k];
                        break;
                }
            }var user = new User();
            user.SessionID = sessionID;
            user.Manager = _;
            __.user = user;
            __.idic = {};
            __.end = false;
            __.sb = _gcl2.default.sb();
            __.streams = [];
        }

        /**
         * 不能和init一起运行，因为init运行时没有Cookie等信息
         */

    }, {
        key: 'initSession',
        value: function () {
            var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(ID) {
                var _pri25, _, __;

                return _regenerator2.default.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                _pri25 = pri(this), _ = _pri25._, __ = _pri25.__;
                                _context2.next = 3;
                                return __.adapter.fillSessionData(__.user);

                            case 3:
                                if (!__.user.SessionID) __.user.SessionID = ID || CreateID();
                                if (__.user.Login && (!__.user.LoginTime || new Date().sub('h', __.user.LoginTime) >= __.passtime)) __.user.Login = false;

                            case 5:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function initSession(_x) {
                return _ref2.apply(this, arguments);
            }

            return initSession;
        }()

        /**
         * 
         * @param {文件路径} file 
         */

    }, {
        key: 'map',
        value: function map(file) {
            //需要知道__dirname;
        }
    }, {
        key: 'write',
        value: function write(data, encoding) {
            var clear = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

            var _pri26 = pri(this),
                _ = _pri26._,
                __ = _pri26.__;

            _.encoding = encoding || _.encoding;
            if (clear) __.sb.clear();
            __.sb.append(data);
        }
    }, {
        key: 'clearWrite',
        value: function clearWrite() {
            var _pri27 = pri(this),
                _ = _pri27._,
                __ = _pri27.__;

            __.sb.clear();
        }
    }, {
        key: 'writeStream',
        value: function writeStream(stream) {
            var _pri28 = pri(this),
                _ = _pri28._,
                __ = _pri28.__;

            __.streams.push(stream);
        }

        /**
         * 导出文件
         * @param {流或者Buffer} obj 
         * @param {附件文件名} name 
         */

    }, {
        key: 'exportFile',
        value: function () {
            var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(obj, name) {
                var _pri29, _, __, stream;

                return _regenerator2.default.wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                _pri29 = pri(this), _ = _pri29._, __ = _pri29.__;

                                if (!__.interrupt) {
                                    _context3.next = 3;
                                    break;
                                }

                                return _context3.abrupt('return');

                            case 3:
                                this.Response.setHeader('content-type', (0, _mime.get)(name));
                                this.Response.setHeader("Content-Disposition", encodeURI("attachment;filename=" + name));
                                if (typeof obj == 'string') _.write(obj, 'utf-8');else if (obj.on) _.writeStream(obj);else {
                                    //_.getResponseStream.write(obj);
                                    stream = new _gcl2.default.ArrayStream();

                                    stream.write(obj);
                                    _.writeStream(stream);
                                }

                            case 6:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this);
            }));

            function exportFile(_x3, _x4) {
                return _ref3.apply(this, arguments);
            }

            return exportFile;
        }()

        /**
         * 导出文件
         * @param {[[name,name],[value,value],[value,value]]} obj 
         * @param {附件文件名} name 
         */

    }, {
        key: 'exportExcel',
        value: function () {
            var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(db, name) {
                var count, _db, i, buffer;

                return _regenerator2.default.wrap(function _callee4$(_context4) {
                    while (1) {
                        switch (_context4.prev = _context4.next) {
                            case 0:
                                count = 0, _db = db, i = 0;

                                while (_gcl2.default.isArray(_db[0])) {
                                    _db = _db[0];
                                    count++;
                                }
                                count == 1 && (db = [db]); //1维要升级成2维
                                count == 0 && (db = [[]]);
                                i = 0;
                                buffer = _nodeXlsx2.default.build(db.map(function (v) {
                                    return {
                                        name: 'sheet' + ++i,
                                        data: v
                                    };
                                }));
                                // console.log(350,name);

                                _context4.next = 8;
                                return this.exportFile(buffer, name);

                            case 8:
                            case 'end':
                                return _context4.stop();
                        }
                    }
                }, _callee4, this);
            }));

            function exportExcel(_x5, _x6) {
                return _ref4.apply(this, arguments);
            }

            return exportExcel;
        }()
    }, {
        key: 'clearStream',
        value: function clearStream() {
            var _pri30 = pri(this),
                _ = _pri30._,
                __ = _pri30.__;

            var ret = __.streams;
            __.streams = [];
            return ret;
        }
    }, {
        key: 'getResponseStream',
        value: function getResponseStream() {
            var _pri31 = pri(this),
                _ = _pri31._,
                __ = _pri31.__;

            if (__.interrupt) return;
            return __.stream || function () {
                var encodings = (__.req.headers['vesh-encoding'] || __.req.headers['accept-encoding-vesh'] || __.req.headers['accept-encoding'] || 'text/plain').replace(/\s/g, '').split(',').filter(function (v) {
                    return _gcl2.default.isValid(v);
                }),
                    stream = null;
                for (var i = 0; i < encodings.length; i++) {
                    var v = encodings[i];
                    //todo 因为gzip和deflate导致发送压缩计算 影响速度
                    switch (v.toLowerCase()) {
                        case 'gzip':
                            _.Response.setHeader("content-encoding", "gzip");
                            stream = _zlib2.default.createGzip();
                            stream.pipe(_.Response);
                            __.stream = stream;
                            return __.stream;
                        case 'deflate':
                            _.Response.setHeader("content-encoding", "deflate");
                            stream = _zlib2.default.Deflate();
                            stream.pipe(_.Response);
                            __.stream = stream;
                            return __.stream;
                        case 'ws':
                        case 'mqtt':
                            return _.Response;
                    }
                }
                //_.Response.setHeader("content-encoding", "text/plain");
                __.stream = _.Response;
                return __.stream;
            }();
        }
    }, {
        key: 'flush',
        value: function () {
            var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
                var _pri32, _, __, st, stream;

                return _regenerator2.default.wrap(function _callee5$(_context5) {
                    while (1) {
                        switch (_context5.prev = _context5.next) {
                            case 0:
                                _pri32 = pri(this), _ = _pri32._, __ = _pri32.__;

                                if (!__.interrupt) {
                                    _context5.next = 3;
                                    break;
                                }

                                return _context5.abrupt('return', false);

                            case 3:
                                if (!(__.sb && __.sb.length > 0)) {
                                    _context5.next = 10;
                                    break;
                                }

                                st = _.getResponseStream();
                                //console.log(394, __.interrupt, __.sb && __.sb.toString(), __.streams && __.streams.length);

                                _context5.next = 7;
                                return _gcl2.default.callback(function (call) {
                                    return st.end(__.sb.clear(), _.encoding, call);
                                });

                            case 7:
                                return _context5.abrupt('return', false);

                            case 10:
                                if (!(__.streams && __.streams.length > 0)) {
                                    _context5.next = 17;
                                    break;
                                }

                                stream = _.getResponseStream();
                                _context5.next = 14;
                                return _gcl2.default.each(__.streams, function (v, next) {
                                    v.on('error', function (err) {
                                        __.log.error('VESH:' + err.stack);
                                        next();
                                    });
                                    v.on('end', next);
                                    //写入文件 
                                    v.pipe(stream, { end: false });
                                }).then(function () {
                                    return _gcl2.default.callback(function (call) {
                                        _.Response.on('finish', function (err) {
                                            if (err) call(err);
                                            _.Response.removeAllListeners('finish');
                                            _.Response.end();
                                            call(null, true);
                                        });
                                        __.stream.end();
                                        __.streams = [];
                                    });
                                });

                            case 14:
                                return _context5.abrupt('return', false);

                            case 17:
                                if (!__.stream) {
                                    _context5.next = 23;
                                    break;
                                }

                                _context5.next = 20;
                                return _gcl2.default.callback(function (call) {
                                    _.Response.on('finish', function () {
                                        _.Response.removeAllListeners('finish');
                                        _.Response.end();
                                        call();
                                    });
                                    __.stream.end();
                                });

                            case 20:
                                return _context5.abrupt('return', false);

                            case 23:
                                return _context5.abrupt('return', true);

                            case 24:
                            case 'end':
                                return _context5.stop();
                        }
                    }
                }, _callee5, this);
            }));

            function flush() {
                return _ref5.apply(this, arguments);
            }

            return flush;
        }()

        /**
         * 中止后续session操作 ，MSocket方法专用
         */

    }, {
        key: 'interrupt',
        value: function () {
            var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
                return _regenerator2.default.wrap(function _callee6$(_context6) {
                    while (1) {
                        switch (_context6.prev = _context6.next) {
                            case 0:
                                pri(this, { interrupt: true });

                            case 1:
                            case 'end':
                                return _context6.stop();
                        }
                    }
                }, _callee6, this);
            }));

            function interrupt() {
                return _ref6.apply(this, arguments);
            }

            return interrupt;
        }()
    }, {
        key: 'isInterrupt',
        value: function isInterrupt() {
            return !!pri(this).__.interrupt;
        }

        /**
         * 从QueryString和Form中获取数据
         * @param {从QueryString和Form中获取数据} k 
         */

    }, {
        key: 'param',
        value: function param(k) {
            var _pri33 = pri(this),
                _ = _pri33._,
                __ = _pri33.__;

            return k ? (_.querystring ? _.querystring[k] : null) || (_.form ? _.form[k] : null) : null;
        }
    }, {
        key: 'Send',


        /**
         * 主动下行其它SessionID
         * @param {*} sessionIDs 
         */
        value: function () {
            var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(sessionIDs) {
                var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

                var _pri34, _, __, rets;

                return _regenerator2.default.wrap(function _callee7$(_context7) {
                    while (1) {
                        switch (_context7.prev = _context7.next) {
                            case 0:
                                _pri34 = pri(this), _ = _pri34._, __ = _pri34.__;

                                sessionIDs = _gcl2.default.isArray(sessionIDs) ? sessionIDs : typeof sessionIDs == 'string' ? sessionIDs.split(',') : null;
                                rets = [];

                                if (!(sessionIDs && __.wsSessionIdic)) {
                                    _context7.next = 7;
                                    break;
                                }

                                sessionIDs.map(function (id) {
                                    var client = __.wsSessionIdic[id];
                                    if (client && client.readyState == _ws2.default.OPEN) {
                                        client.send(_gcl2.default.toJsonString(_gcl2.default.merge({
                                            event: 'send',
                                            ID: _gcl2.default.SNOWID(),
                                            data: ''
                                        }, data)));
                                        rets.push(id);
                                    }
                                });
                                _context7.next = 8;
                                break;

                            case 7:
                                throw Error('不是webSocket会话!');

                            case 8:
                                return _context7.abrupt('return', rets);

                            case 9:
                            case 'end':
                                return _context7.stop();
                        }
                    }
                }, _callee7, this);
            }));

            function Send(_x7) {
                return _ref7.apply(this, arguments);
            }

            return Send;
        }()
    }, {
        key: 'AppSettings',
        value: function AppSettings(k) {
            var _pri35 = pri(this),
                _ = _pri35._,
                __ = _pri35.__;

            return _config2.default.AppSettings(__.config, k);
        }

        /**
         * 用户信息
         */

    }, {
        key: 'hasRight',
        value: function () {
            var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(key) {
                var value;
                return _regenerator2.default.wrap(function _callee8$(_context8) {
                    while (1) {
                        switch (_context8.prev = _context8.next) {
                            case 0:
                                _context8.next = 2;
                                return this.data('.Permissions');

                            case 2:
                                value = _context8.sent;

                                if (!_gcl2.default.isArray(value.data(key))) {
                                    _context8.next = 5;
                                    break;
                                }

                                throw new Error(key + '\u7684\u6743\u9650\u503C\u91CD\u590D!');

                            case 5:
                                if (!(_gcl2.default.isValid(value) && value.data(key))) {
                                    _context8.next = 11;
                                    break;
                                }

                                _context8.next = 8;
                                return this.Permission.hasRight(value.data(key));

                            case 8:
                                _context8.t0 = _context8.sent;
                                _context8.next = 12;
                                break;

                            case 11:
                                _context8.t0 = false;

                            case 12:
                                return _context8.abrupt('return', _context8.t0);

                            case 13:
                            case 'end':
                                return _context8.stop();
                        }
                    }
                }, _callee8, this);
            }));

            function hasRight(_x9) {
                return _ref8.apply(this, arguments);
            }

            return hasRight;
        }()
    }, {
        key: 'data',
        value: function () {
            var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9(k) {
                var _pri36, _, __, _data2;

                return _regenerator2.default.wrap(function _callee9$(_context9) {
                    while (1) {
                        switch (_context9.prev = _context9.next) {
                            case 0:
                                _pri36 = pri(this), _ = _pri36._, __ = _pri36.__;

                                if (!(k.toLowerCase() == _.User.Name.toLowerCase())) {
                                    _context9.next = 5;
                                    break;
                                }

                                return _context9.abrupt('return', _.User);

                            case 5:
                                if (!__.idic[k]) {
                                    _context9.next = 9;
                                    break;
                                }

                                return _context9.abrupt('return', __.idic[k]);

                            case 9:
                                _context9.next = 11;
                                return __.adapter.getSessionData(this, _.User.SessionID, k);

                            case 11:
                                _data2 = _context9.sent;

                                __.idic[k] = _data2;
                                return _context9.abrupt('return', __.idic[k]);

                            case 14:
                            case 'end':
                                return _context9.stop();
                        }
                    }
                }, _callee9, this);
            }));

            function data(_x10) {
                return _ref9.apply(this, arguments);
            }

            return data;
        }()
    }, {
        key: 'update',
        value: function () {
            var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee11() {
                var _this3 = this;

                var _pri37, _, __;

                return _regenerator2.default.wrap(function _callee11$(_context11) {
                    while (1) {
                        switch (_context11.prev = _context11.next) {
                            case 0:
                                _pri37 = pri(this), _ = _pri37._, __ = _pri37.__;

                                if (_.isStatic) {
                                    _context11.next = 11;
                                    break;
                                }

                                _context11.next = 4;
                                return _gcl2.default.forC(__.idic, function () {
                                    var _ref11 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10(k, v) {
                                        return _regenerator2.default.wrap(function _callee10$(_context10) {
                                            while (1) {
                                                switch (_context10.prev = _context10.next) {
                                                    case 0:
                                                        if (!v.IsClear) {
                                                            _context10.next = 5;
                                                            break;
                                                        }

                                                        _context10.next = 3;
                                                        return __.adapter.clearSessionData(v);

                                                    case 3:
                                                        _context10.next = 7;
                                                        break;

                                                    case 5:
                                                        _context10.next = 7;
                                                        return __.adapter.saveSessionData(v);

                                                    case 7:
                                                        return _context10.abrupt('return', false);

                                                    case 8:
                                                    case 'end':
                                                        return _context10.stop();
                                                }
                                            }
                                        }, _callee10, _this3);
                                    }));

                                    return function (_x11, _x12) {
                                        return _ref11.apply(this, arguments);
                                    };
                                }());

                            case 4:
                                if (!__.user.IsClear) {
                                    _context11.next = 9;
                                    break;
                                }

                                _context11.next = 7;
                                return __.adapter.clearSessionData(__.user);

                            case 7:
                                _context11.next = 11;
                                break;

                            case 9:
                                _context11.next = 11;
                                return __.adapter.saveSessionData(__.user);

                            case 11:
                                return _context11.abrupt('return');

                            case 12:
                            case 'end':
                                return _context11.stop();
                        }
                    }
                }, _callee11, this);
            }));

            function update() {
                return _ref10.apply(this, arguments);
            }

            return update;
        }()
    }, {
        key: 'dispose',
        value: function dispose() {
            var _pri38 = pri(this),
                _ = _pri38._,
                __ = _pri38.__;

            __.user.dispose();
            for (var k in __.idic) {
                __.idic[k].dispose();
            }
        }

        /**
         * 根据键值进行正则判断
         * @param {*} key 
         * @param {*} regex 
         * @param {*} error 
         * @param {*} isRequire 
         */

    }, {
        key: 'testRegex',
        value: function testRegex(key, regex, error, isRequire) {
            _gcl2.default.testRegex(this.param(key), regex, error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是数字
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} isRequire 
         */

    }, {
        key: 'testNumber',
        value: function testNumber(key, error, isRequire) {
            _gcl2.default.testNumber(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是数字
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testInt',
        value: function testInt(key, error, isRequire) {
            _gcl2.default.testInt(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是字母
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testLetter',
        value: function testLetter(key, error, isRequire) {
            _gcl2.default.testLetter(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是数字
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testPassword',
        value: function testPassword(key, error, isRequire) {
            _gcl2.default.testPassword(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是非空必填
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testCard',


        /**
         * 限制参数满足是身份证
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */
        value: function testCard(key, error, isRequire) {
            _gcl2.default.testCard(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是手机号
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testMobile',
        value: function testMobile(key, error, isRequire) {
            _gcl2.default.testMobile(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是座机
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testPhone',
        value: function testPhone(key, error, isRequire) {
            _gcl2.default.testPhone(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是网络地址
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testUrl',
        value: function testUrl(key, error, isRequire) {
            _gcl2.default.testUrl(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是电子邮箱
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testEmail',
        value: function testEmail(key, error, isRequire) {
            _gcl2.default.testEmail(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是中文
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testChinese',
        value: function testChinese(key, error, isRequire) {
            _gcl2.default.testChinese(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是QQ
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testQQ',
        value: function testQQ(key, error, isRequire) {
            _gcl2.default.testQQ(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是邮政编码
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testZipCode',
        value: function testZipCode(key, error, isRequire) {
            _gcl2.default.testZipCode(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是IP
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testIP',
        value: function testIP(key, error, isRequire) {
            _gcl2.default.testIP(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是金额（2位小数）
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testCurreny',
        value: function testCurreny(key, error, isRequire) {
            _gcl2.default.testCurreny(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是数字
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} isRequire 
         */

    }, {
        key: 'testNumberOrNull',
        value: function testNumberOrNull(key, error, isRequire) {
            _gcl2.default.testNumberOrNull(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是数字
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testIntOrNull',
        value: function testIntOrNull(key, error, isRequire) {
            _gcl2.default.testIntOrNull(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是字母
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testLetterOrNull',
        value: function testLetterOrNull(key, error, isRequire) {
            _gcl2.default.testLetterOrNull(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是数字
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testPasswordOrNull',
        value: function testPasswordOrNull(key, error, isRequire) {
            _gcl2.default.testPasswordOrNull(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是非空必填
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testCardOrNull',


        /**
         * 限制参数满足是身份证
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */
        value: function testCardOrNull(key, error, isRequire) {
            _gcl2.default.testCardOrNull(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是手机号
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testMobileOrNull',
        value: function testMobileOrNull(key, error, isRequire) {
            _gcl2.default.testMobileOrNull(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是座机
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testPhoneOrNull',
        value: function testPhoneOrNull(key, error, isRequire) {
            _gcl2.default.testPhoneOrNull(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是网络地址
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testUrlOrNull',
        value: function testUrlOrNull(key, error, isRequire) {
            _gcl2.default.testUrlOrNull(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是电子邮箱
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testEmailOrNull',
        value: function testEmailOrNull(key, error, isRequire) {
            _gcl2.default.testEmailOrNull(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是中文
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testChineseOrNull',
        value: function testChineseOrNull(key, error, isRequire) {
            _gcl2.default.testChineseOrNull(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是QQ
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testQQOrNull',
        value: function testQQOrNull(key, error, isRequire) {
            _gcl2.default.testQQOrNull(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是邮政编码
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testZipCodeOrNull',
        value: function testZipCodeOrNull(key, error, isRequire) {
            _gcl2.default.testZipCodeOrNull(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是IP
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testIPOrNull',
        value: function testIPOrNull(key, error, isRequire) {
            _gcl2.default.testIPOrNull(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 限制参数满足是金额（2位小数）
         * @param {要判断的值} value
         * @param {错误说明} error 
         * @param {是否必填} testRequire 
         */

    }, {
        key: 'testCurrenyOrNull',
        value: function testCurrenyOrNull(key, error, isRequire) {
            _gcl2.default.testCurrenyOrNull(this.param(key), error, key, isRequire);
            return this.param(key);
        }

        /**
         * 测试访问方法 多个为;号隔开
         */

    }, {
        key: 'testMethod',
        value: function testMethod() {
            var methods = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "GET";

            var method = {};
            methods = methods.toUpperCase();
            methods.split(';').forEach(function (v) {
                return method[v] = true;
            });
            if (!method[this.Request.method]) {
                var e = new Error("限制的Method为" + methods);
                e.status = 401;
                throw e;
            }
            return true;
        }
    }, {
        key: 'testGet',


        /**
         * 测试访问方法为GET
         */
        value: function testGet() {
            return this.testMethod('get');
        }

        /**
         * 测试访问方法为POST
         */

    }, {
        key: 'testPost',
        value: function testPost() {
            return this.testMethod('post');
        }

        /**
         * 限制Restful几个方法
         */

    }, {
        key: 'testRestful',
        value: function testRestful() {
            return this.testMethod('get;post;put;delete');
        }

        /**
         * 
         * @param {权限名,号隔开} key 
         * @param {错误说明} error 
         */

    }, {
        key: 'testPermission',
        value: function () {
            var _ref12 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee13(key, error) {
                var _this4 = this;

                var _pri39, _, __, val, e;

                return _regenerator2.default.wrap(function _callee13$(_context13) {
                    while (1) {
                        switch (_context13.prev = _context13.next) {
                            case 0:
                                _pri39 = pri(this), _ = _pri39._, __ = _pri39.__;
                                val = false;
                                _context13.next = 4;
                                return _gcl2.default.each(key.split(','), function () {
                                    var _ref13 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee12(v) {
                                        return _regenerator2.default.wrap(function _callee12$(_context12) {
                                            while (1) {
                                                switch (_context12.prev = _context12.next) {
                                                    case 0:
                                                        _context12.t0 = val;

                                                        if (_context12.t0) {
                                                            _context12.next = 5;
                                                            break;
                                                        }

                                                        _context12.next = 4;
                                                        return _.hasRight(v);

                                                    case 4:
                                                        _context12.t0 = _context12.sent;

                                                    case 5:
                                                        val = _context12.t0;
                                                        return _context12.abrupt('return', false);

                                                    case 7:
                                                    case 'end':
                                                        return _context12.stop();
                                                }
                                            }
                                        }, _callee12, _this4);
                                    }));

                                    return function (_x16) {
                                        return _ref13.apply(this, arguments);
                                    };
                                }(), true);

                            case 4:
                                if (val) {
                                    _context13.next = 8;
                                    break;
                                }

                                e = new Error('\u8BE5\u64CD\u4F5C\u9700\u8981' + key + '\u6743\u9650');

                                e.status = 401;
                                throw e;

                            case 8:
                                return _context13.abrupt('return', true);

                            case 9:
                            case 'end':
                                return _context13.stop();
                        }
                    }
                }, _callee13, this);
            }));

            function testPermission(_x14, _x15) {
                return _ref12.apply(this, arguments);
            }

            return testPermission;
        }()

        /**
         *  
         * @param {限制键} key 
         * @param {错误提示} error 
         * @param {限制有效期内单进程只能访问200次} count 
         * @param {限制有效期,时长不能小于1s} time 
         * @param {限制键的最大个数,默认一千万} limit 
         */

    }, {
        key: 'testLimit',
        value: function testLimit() {
            var key = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'testLimit';
            var error = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '单位时间内请求超过上限';
            var count = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 200;

            //借用全局对象 sessionDataAdapter 进行数据缓存!和定时清理
            var _pri40 = pri(this),
                __ = _pri40.__,
                name = '____limit';

            var lim = __.adapter[name] || function () {
                var _limit = {
                    cache: {},
                    checker: new (function () {
                        function _class2() {
                            (0, _classCallCheck3.default)(this, _class2);

                            var _pri41 = pri(this, {
                                go: false,
                                run: function run() {
                                    if (__.go) {
                                        setTimeout(function () {
                                            _.check();
                                            __.run();
                                        }, 1000);
                                    }
                                }
                            }),
                                _ = _pri41._,
                                __ = _pri41.__;
                        }

                        (0, _createClass3.default)(_class2, [{
                            key: 'check',
                            value: function check() {
                                delete _limit.cache;
                                _limit.cache = {};
                            }
                        }, {
                            key: 'start',
                            value: function start() {
                                var _pri42 = pri(this),
                                    __ = _pri42.__;

                                __.go = true;
                                __.run();
                            }
                        }, {
                            key: 'stop',
                            value: function stop() {
                                pri(this).__.go = false;
                            }
                        }]);
                        return _class2;
                    }())()
                };
                __.adapter[name] = _limit;
                _limit.checker.start();
                return _limit;
            }();
            lim.cache[key] = lim.cache[key] + 1 || 1;
            if (lim.cache[key] >= count) throw new Error(error || '\u952E\u503C' + key + '\u57281\u79D2\u5185\u5DF2\u7ECF\u5230\u8FBE\u4E86\u4E0A\u9650' + count + '!');
            return true;
        }
    }, {
        key: 'IsEnd',
        get: function get() {
            var _pri43 = pri(this),
                __ = _pri43.__;

            return __.end;
        }
    }, {
        key: 'Config',
        get: function get() {
            var _pri44 = pri(this),
                _ = _pri44._,
                __ = _pri44.__;

            return __.config;
        }
    }, {
        key: 'Middler',
        get: function get() {
            var _pri45 = pri(this),
                _ = _pri45._,
                __ = _pri45.__;

            return __.middler;
        }
    }, {
        key: 'Log',
        get: function get() {
            var _pri46 = pri(this),
                _ = _pri46._,
                __ = _pri46.__;

            return __.log;
        }
    }, {
        key: 'Ni',
        get: function get() {
            var _pri47 = pri(this),
                _ = _pri47._,
                __ = _pri47.__;

            return __.ni;
        }
    }, {
        key: 'Request',
        get: function get() {
            var _pri48 = pri(this),
                _ = _pri48._,
                __ = _pri48.__;

            return __.req;
        }
    }, {
        key: 'Response',
        get: function get() {
            var _pri49 = pri(this),
                _ = _pri49._,
                __ = _pri49.__;

            return __.rep;
        }
    }, {
        key: 'WebSocket',
        get: function get() {
            var _pri50 = pri(this),
                _ = _pri50._,
                __ = _pri50.__;

            return __.req.webSocket;
        }
    }, {
        key: 'Message',
        get: function get() {
            var _pri51 = pri(this),
                _ = _pri51._,
                __ = _pri51.__;

            return __.req.message;
        }
    }, {
        key: 'User',
        get: function get() {
            var _pri52 = pri(this),
                _ = _pri52._,
                __ = _pri52.__;

            return __.user;
        }

        /**
         * 角色串
         */

    }, {
        key: 'EIDS',
        get: function get() {
            var _pri53 = pri(this),
                _ = _pri53._,
                __ = _pri53.__;

            __.eids = __.eids || new (function () {
                function _class3() {
                    (0, _classCallCheck3.default)(this, _class3);
                }

                (0, _createClass3.default)(_class3, [{
                    key: 'get',
                    value: function () {
                        var _ref14 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee14() {
                            var eids, value;
                            return _regenerator2.default.wrap(function _callee14$(_context14) {
                                while (1) {
                                    switch (_context14.prev = _context14.next) {
                                        case 0:
                                            _context14.next = 2;
                                            return _.data('.EIDS');

                                        case 2:
                                            eids = _context14.sent;
                                            value = eids.data('values') || '';

                                            eids.data('values', value);
                                            return _context14.abrupt('return', value);

                                        case 6:
                                        case 'end':
                                            return _context14.stop();
                                    }
                                }
                            }, _callee14, this);
                        }));

                        function get() {
                            return _ref14.apply(this, arguments);
                        }

                        return get;
                    }()
                }, {
                    key: 'clear',
                    value: function () {
                        var _ref15 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee15() {
                            return _regenerator2.default.wrap(function _callee15$(_context15) {
                                while (1) {
                                    switch (_context15.prev = _context15.next) {
                                        case 0:
                                            _context15.next = 2;
                                            return _.data('.EIDS');

                                        case 2:
                                            _context15.sent.clear();

                                        case 3:
                                        case 'end':
                                            return _context15.stop();
                                    }
                                }
                            }, _callee15, this);
                        }));

                        function clear() {
                            return _ref15.apply(this, arguments);
                        }

                        return clear;
                    }()
                }, {
                    key: 'set',
                    value: function () {
                        var _ref16 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee16() {
                            var v = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

                            var _pri54, __;

                            return _regenerator2.default.wrap(function _callee16$(_context16) {
                                while (1) {
                                    switch (_context16.prev = _context16.next) {
                                        case 0:
                                            _pri54 = pri(this), __ = _pri54.__;

                                            if (!v) {
                                                _context16.next = 6;
                                                break;
                                            }

                                            _context16.next = 4;
                                            return _.data('.EIDS');

                                        case 4:
                                            _context16.t0 = v;

                                            _context16.sent.data('values', _context16.t0);

                                        case 6:
                                        case 'end':
                                            return _context16.stop();
                                    }
                                }
                            }, _callee16, this);
                        }));

                        function set() {
                            return _ref16.apply(this, arguments);
                        }

                        return set;
                    }()
                }]);
                return _class3;
            }())();
            return __.eids;
        }

        /**
         * 管理角色串
         */

    }, {
        key: 'MEIDS',
        get: function get() {
            var _pri55 = pri(this),
                _ = _pri55._,
                __ = _pri55.__;

            __.meids = __.meids || new (function () {
                function _class4() {
                    (0, _classCallCheck3.default)(this, _class4);
                }

                (0, _createClass3.default)(_class4, [{
                    key: 'get',
                    value: function () {
                        var _ref17 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee17() {
                            var meids, value;
                            return _regenerator2.default.wrap(function _callee17$(_context17) {
                                while (1) {
                                    switch (_context17.prev = _context17.next) {
                                        case 0:
                                            _context17.next = 2;
                                            return _.data('.MEIDS');

                                        case 2:
                                            meids = _context17.sent;
                                            value = meids.data('values') || '';

                                            meids.data('values', value);
                                            return _context17.abrupt('return', value);

                                        case 6:
                                        case 'end':
                                            return _context17.stop();
                                    }
                                }
                            }, _callee17, this);
                        }));

                        function get() {
                            return _ref17.apply(this, arguments);
                        }

                        return get;
                    }()
                }, {
                    key: 'clear',
                    value: function () {
                        var _ref18 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee18() {
                            return _regenerator2.default.wrap(function _callee18$(_context18) {
                                while (1) {
                                    switch (_context18.prev = _context18.next) {
                                        case 0:
                                            _context18.next = 2;
                                            return _.data('.MEIDS');

                                        case 2:
                                            _context18.sent.clear();

                                        case 3:
                                        case 'end':
                                            return _context18.stop();
                                    }
                                }
                            }, _callee18, this);
                        }));

                        function clear() {
                            return _ref18.apply(this, arguments);
                        }

                        return clear;
                    }()
                }, {
                    key: 'set',
                    value: function () {
                        var _ref19 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee19() {
                            var v = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

                            var _pri56, __;

                            return _regenerator2.default.wrap(function _callee19$(_context19) {
                                while (1) {
                                    switch (_context19.prev = _context19.next) {
                                        case 0:
                                            _pri56 = pri(this), __ = _pri56.__;

                                            if (!v) {
                                                _context19.next = 6;
                                                break;
                                            }

                                            _context19.next = 4;
                                            return _.data('.MEIDS');

                                        case 4:
                                            _context19.t0 = v;

                                            _context19.sent.data('values', _context19.t0);

                                        case 6:
                                        case 'end':
                                            return _context19.stop();
                                    }
                                }
                            }, _callee19, this);
                        }));

                        function set() {
                            return _ref19.apply(this, arguments);
                        }

                        return set;
                    }()
                }]);
                return _class4;
            }())();
            return __.meids;
        }

        /**
         * 菜单数组
         */

    }, {
        key: 'MENUS',
        get: function get() {
            var _pri57 = pri(this),
                _ = _pri57._,
                __ = _pri57.__;

            __.menus = __.menus || new (function () {
                function _class5() {
                    (0, _classCallCheck3.default)(this, _class5);
                }

                (0, _createClass3.default)(_class5, [{
                    key: 'get',
                    value: function () {
                        var _ref20 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee20() {
                            var menus, ret;
                            return _regenerator2.default.wrap(function _callee20$(_context20) {
                                while (1) {
                                    switch (_context20.prev = _context20.next) {
                                        case 0:
                                            _context20.next = 2;
                                            return _.data('.MENUS');

                                        case 2:
                                            menus = _context20.sent;
                                            ret = menus.data('values') || '';

                                            menus.data('values', ret);
                                            if (_gcl2.default.isValid(ret) && ret.length > 0) ret = _gcl2.default.json(ret);
                                            return _context20.abrupt('return', ret);

                                        case 7:
                                        case 'end':
                                            return _context20.stop();
                                    }
                                }
                            }, _callee20, this);
                        }));

                        function get() {
                            return _ref20.apply(this, arguments);
                        }

                        return get;
                    }()
                }, {
                    key: 'clear',
                    value: function () {
                        var _ref21 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee21() {
                            return _regenerator2.default.wrap(function _callee21$(_context21) {
                                while (1) {
                                    switch (_context21.prev = _context21.next) {
                                        case 0:
                                            _context21.next = 2;
                                            return _.data('.MENUS');

                                        case 2:
                                            _context21.sent.clear();

                                        case 3:
                                        case 'end':
                                            return _context21.stop();
                                    }
                                }
                            }, _callee21, this);
                        }));

                        function clear() {
                            return _ref21.apply(this, arguments);
                        }

                        return clear;
                    }()
                }, {
                    key: 'set',
                    value: function () {
                        var _ref22 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee22() {
                            var v = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

                            var _pri58, __;

                            return _regenerator2.default.wrap(function _callee22$(_context22) {
                                while (1) {
                                    switch (_context22.prev = _context22.next) {
                                        case 0:
                                            _pri58 = pri(this), __ = _pri58.__;

                                            if (!v) {
                                                _context22.next = 6;
                                                break;
                                            }

                                            _context22.next = 4;
                                            return _.data('.MENUS');

                                        case 4:
                                            _context22.t0 = _gcl2.default.toJsonString(v);

                                            _context22.sent.data('values', _context22.t0);

                                        case 6:
                                        case 'end':
                                            return _context22.stop();
                                    }
                                }
                            }, _callee22, this);
                        }));

                        function set() {
                            return _ref22.apply(this, arguments);
                        }

                        return set;
                    }()
                }]);
                return _class5;
            }())();
            return __.menus;
        }

        /**
         * 权限串
         */

    }, {
        key: 'Permission',
        get: function get() {
            var _pri59 = pri(this),
                _ = _pri59._,
                __ = _pri59.__;

            __.pers = __.pers || new (function () {
                function _class6() {
                    (0, _classCallCheck3.default)(this, _class6);

                    var that = this;
                    pri(that, { params: {}, hasLoad: false });
                }

                (0, _createClass3.default)(_class6, [{
                    key: 'hasRight',
                    value: function () {
                        var _ref23 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee23(v) {
                            var _pri60, __, config, vals, charset;

                            return _regenerator2.default.wrap(function _callee23$(_context23) {
                                while (1) {
                                    switch (_context23.prev = _context23.next) {
                                        case 0:
                                            _pri60 = pri(this), __ = _pri60.__;

                                            if (__.hasLoad) {
                                                _context23.next = 10;
                                                break;
                                            }

                                            _context23.next = 4;
                                            return _.data('.PIDS');

                                        case 4:
                                            config = _context23.sent;
                                            vals = config.data('values') || '';

                                            config.data('values', vals);
                                            charset = vals.indexOf(',') >= 0 ? ',' : ';';

                                            vals.split(charset).forEach(function (v) {
                                                return v.length > 0 && (__.params[v] = true);
                                            });
                                            __.hasLoad = true;

                                        case 10:
                                            return _context23.abrupt('return', __.params[v] || false);

                                        case 11:
                                        case 'end':
                                            return _context23.stop();
                                    }
                                }
                            }, _callee23, this);
                        }));

                        function hasRight(_x23) {
                            return _ref23.apply(this, arguments);
                        }

                        return hasRight;
                    }()
                }, {
                    key: 'set',
                    value: function () {
                        var _ref24 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee24() {
                            var v = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

                            var _pri61, __, charset;

                            return _regenerator2.default.wrap(function _callee24$(_context24) {
                                while (1) {
                                    switch (_context24.prev = _context24.next) {
                                        case 0:
                                            _pri61 = pri(this), __ = _pri61.__;

                                            if (!v) {
                                                _context24.next = 9;
                                                break;
                                            }

                                            _context24.next = 4;
                                            return _.data('.PIDS');

                                        case 4:
                                            _context24.t0 = v;

                                            _context24.sent.data('values', _context24.t0);

                                            charset = v.indexOf(',') >= 0 ? ',' : ';';

                                            v.split(charset).forEach(function (v) {
                                                return v.length > 0 && (__.params[v] = true);
                                            });
                                            __.hasLoad = true;

                                        case 9:
                                        case 'end':
                                            return _context24.stop();
                                    }
                                }
                            }, _callee24, this);
                        }));

                        function set() {
                            return _ref24.apply(this, arguments);
                        }

                        return set;
                    }()
                }, {
                    key: 'clear',
                    value: function () {
                        var _ref25 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee25() {
                            return _regenerator2.default.wrap(function _callee25$(_context25) {
                                while (1) {
                                    switch (_context25.prev = _context25.next) {
                                        case 0:
                                            _context25.next = 2;
                                            return _.data('.PIDS');

                                        case 2:
                                            _context25.sent.clear();

                                        case 3:
                                        case 'end':
                                            return _context25.stop();
                                    }
                                }
                            }, _callee25, this);
                        }));

                        function clear() {
                            return _ref25.apply(this, arguments);
                        }

                        return clear;
                    }()
                }, {
                    key: 'get',
                    value: function () {
                        var _ref26 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee26() {
                            var _pri62, __;

                            return _regenerator2.default.wrap(function _callee26$(_context26) {
                                while (1) {
                                    switch (_context26.prev = _context26.next) {
                                        case 0:
                                            _pri62 = pri(this), __ = _pri62.__;
                                            _context26.next = 3;
                                            return _.data('.PIDS');

                                        case 3:
                                            _context26.t0 = _context26.sent.data('values');

                                            if (_context26.t0) {
                                                _context26.next = 6;
                                                break;
                                            }

                                            _context26.t0 = '';

                                        case 6:
                                            return _context26.abrupt('return', _context26.t0.replace(/;/g, ','));

                                        case 7:
                                        case 'end':
                                            return _context26.stop();
                                    }
                                }
                            }, _callee26, this);
                        }));

                        function get() {
                            return _ref26.apply(this, arguments);
                        }

                        return get;
                    }()
                }]);
                return _class6;
            }())();
            return __.pers;
        }
    }]);
    return SessionDataManager;
}();
/**
 * ASessionSource:数据源基类，定义load,save,clear三个方法
 */
var ASessionSource = exports.ASessionSource = function () {
    function ASessionSource() {
        (0, _classCallCheck3.default)(this, ASessionSource);

        pri(this);
    }

    (0, _createClass3.default)(ASessionSource, [{
        key: 'load',
        value: function () {
            var _ref27 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee27(sdm, id, name) {
                return _regenerator2.default.wrap(function _callee27$(_context27) {
                    while (1) {
                        switch (_context27.prev = _context27.next) {
                            case 0:
                                return _context27.abrupt('return', "");

                            case 1:
                            case 'end':
                                return _context27.stop();
                        }
                    }
                }, _callee27, this);
            }));

            function load(_x25, _x26, _x27) {
                return _ref27.apply(this, arguments);
            }

            return load;
        }()
    }, {
        key: 'save',
        value: function () {
            var _ref28 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee28(sd, data) {
                return _regenerator2.default.wrap(function _callee28$(_context28) {
                    while (1) {
                        switch (_context28.prev = _context28.next) {
                            case 0:
                            case 'end':
                                return _context28.stop();
                        }
                    }
                }, _callee28, this);
            }));

            function save(_x28, _x29) {
                return _ref28.apply(this, arguments);
            }

            return save;
        }()
    }, {
        key: 'clear',
        value: function () {
            var _ref29 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee29(sd) {
                return _regenerator2.default.wrap(function _callee29$(_context29) {
                    while (1) {
                        switch (_context29.prev = _context29.next) {
                            case 0:
                            case 'end':
                                return _context29.stop();
                        }
                    }
                }, _callee29, this);
            }));

            function clear(_x30) {
                return _ref29.apply(this, arguments);
            }

            return clear;
        }()
    }]);
    return ASessionSource;
}();
/**
 * 测试用常量会话源
 */
var ConstSessionSource = exports.ConstSessionSource = function (_ASessionSource) {
    (0, _inherits3.default)(ConstSessionSource, _ASessionSource);

    function ConstSessionSource(value) {
        (0, _classCallCheck3.default)(this, ConstSessionSource);

        var _this5 = (0, _possibleConstructorReturn3.default)(this, (ConstSessionSource.__proto__ || (0, _getPrototypeOf2.default)(ConstSessionSource)).call(this));

        var _pri63 = pri(_this5, { value: value }),
            _ = _pri63._,
            __ = _pri63.__;

        return _this5;
    }

    (0, _createClass3.default)(ConstSessionSource, [{
        key: 'load',
        value: function load(sdm, id, name) {
            var _pri64 = pri(this),
                _ = _pri64._,
                __ = _pri64.__;

            return __.value;
        }
    }]);
    return ConstSessionSource;
}(ASessionSource);

/**
 * 数据源集合 借助CookieModuler完成Cookie会话处理
 */
var CookieSessionSource = exports.CookieSessionSource = function (_ASessionSource2) {
    (0, _inherits3.default)(CookieSessionSource, _ASessionSource2);

    function CookieSessionSource() {
        var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        (0, _classCallCheck3.default)(this, CookieSessionSource);

        var _this6 = (0, _possibleConstructorReturn3.default)(this, (CookieSessionSource.__proto__ || (0, _getPrototypeOf2.default)(CookieSessionSource)).call(this));

        typeof config == 'string' && (config = { domain: config });

        var _pri65 = pri(_this6, { config: config }),
            _ = _pri65._,
            __ = _pri65.__;

        return _this6;
    }

    (0, _createClass3.default)(CookieSessionSource, [{
        key: 'load',
        value: function () {
            var _ref30 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee30(sdm, id, name) {
                return _regenerator2.default.wrap(function _callee30$(_context30) {
                    while (1) {
                        switch (_context30.prev = _context30.next) {
                            case 0:
                                if (!(sdm && sdm.Cookies && (sdm.Cookies[name] || sdm.SetCookies[name]))) {
                                    _context30.next = 4;
                                    break;
                                }

                                return _context30.abrupt('return', _querystring2.default.stringify((sdm.SetCookies[name] || sdm.Cookies[name]).value));

                            case 4:
                                return _context30.abrupt('return', null);

                            case 5:
                            case 'end':
                                return _context30.stop();
                        }
                    }
                }, _callee30, this);
            }));

            function load(_x32, _x33, _x34) {
                return _ref30.apply(this, arguments);
            }

            return load;
        }()
    }, {
        key: 'clear',
        value: function () {
            var _ref31 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee31(sd) {
                var _pri66, __, domain;

                return _regenerator2.default.wrap(function _callee31$(_context31) {
                    while (1) {
                        switch (_context31.prev = _context31.next) {
                            case 0:
                                _pri66 = pri(this), __ = _pri66.__;

                                if (sd && sd.Name && sd.Manager && sd.Manager.SetCookies) {
                                    domain = '';

                                    if (sd.Manager.url.hostname && sd.Manager.url.hostname.match(/[a-zA-Z]/g)) {
                                        domain = sd.Manager.url.hostname.split('.');
                                        domain = '.' + domain.slice(domain.length - 2).join('.');
                                    }
                                    sd.Manager.SetCookies[sd.Name] = new _cookie2.default.Cookie(_gcl2.default.merge({ domain: domain }, __.config, { name: sd.Name, expires: new Date() }));
                                }
                                return _context31.abrupt('return', true);

                            case 3:
                            case 'end':
                                return _context31.stop();
                        }
                    }
                }, _callee31, this);
            }));

            function clear(_x35) {
                return _ref31.apply(this, arguments);
            }

            return clear;
        }()
    }, {
        key: 'save',
        value: function save(sd, data) {
            var _pri67 = pri(this),
                __ = _pri67.__;

            if (sd && sd.Name && sd.Manager && sd.Manager.SetCookies) {
                var domain = '';
                if (sd.Manager.url.hostname && sd.Manager.url.hostname.match(/[a-zA-Z]/g)) {
                    domain = sd.Manager.url.hostname.split('.');
                    domain = '.' + domain.slice(domain.length - 2).join('.');
                }
                if (sd.Manager.SetCookies[sd.Name]) {
                    if (_gcl2.default.toJsonString(__.config).length > 2) _gcl2.default.merge({ domain: domain }, sd.Manager.SetCookies[sd.Name], __.config, true);
                } else {
                    sd.Manager.SetCookies[sd.Name] = new _cookie2.default.Cookie(_gcl2.default.merge({ domain: domain }, __.config, { name: sd.Name }));
                }
                sd.Manager.SetCookies[sd.Name].value = data;
            }
            return true;
        }
    }]);
    return CookieSessionSource;
}(ASessionSource);
/**
 * SecuritySessionSourceDecorator:借助crypter完成加密会话处理
 */
var SecuritySessionSourceDecorator = exports.SecuritySessionSourceDecorator = function (_ASessionSource3) {
    (0, _inherits3.default)(SecuritySessionSourceDecorator, _ASessionSource3);

    function SecuritySessionSourceDecorator(resource, crypter) {
        (0, _classCallCheck3.default)(this, SecuritySessionSourceDecorator);

        var _this7 = (0, _possibleConstructorReturn3.default)(this, (SecuritySessionSourceDecorator.__proto__ || (0, _getPrototypeOf2.default)(SecuritySessionSourceDecorator)).call(this));

        pri(_this7, { res: resource, crypter: crypter });
        return _this7;
    }

    (0, _createClass3.default)(SecuritySessionSourceDecorator, [{
        key: 'load',
        value: function () {
            var _ref32 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee32(sdm, id, name) {
                var _pri68, _, __, data;

                return _regenerator2.default.wrap(function _callee32$(_context32) {
                    while (1) {
                        switch (_context32.prev = _context32.next) {
                            case 0:
                                _pri68 = pri(this), _ = _pri68._, __ = _pri68.__;
                                _context32.next = 3;
                                return __.res.load(sdm, id, name);

                            case 3:
                                data = _context32.sent;

                                data = data ? data.split ? _querystring2.default.parse(data) : data : "";
                                if (data['se']) data = _gcl2.default.json(__.crypter.decrypt(data['se']));
                                return _context32.abrupt('return', data);

                            case 7:
                            case 'end':
                                return _context32.stop();
                        }
                    }
                }, _callee32, this);
            }));

            function load(_x36, _x37, _x38) {
                return _ref32.apply(this, arguments);
            }

            return load;
        }()
    }, {
        key: 'save',
        value: function () {
            var _ref33 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee33(sd, data) {
                var _pri69, _, __, k;

                return _regenerator2.default.wrap(function _callee33$(_context33) {
                    while (1) {
                        switch (_context33.prev = _context33.next) {
                            case 0:
                                _pri69 = pri(this), _ = _pri69._, __ = _pri69.__;
                                _context33.t0 = _regenerator2.default.keys(data);

                            case 2:
                                if ((_context33.t1 = _context33.t0()).done) {
                                    _context33.next = 9;
                                    break;
                                }

                                k = _context33.t1.value;
                                _context33.next = 6;
                                return __.res.save(sd, { se: __.crypter.encrypt(data.split ? data : _gcl2.default.toJsonString(data)) });

                            case 6:
                                return _context33.abrupt('return', true);

                            case 9:
                                return _context33.abrupt('return', false);

                            case 10:
                            case 'end':
                                return _context33.stop();
                        }
                    }
                }, _callee33, this);
            }));

            function save(_x39, _x40) {
                return _ref33.apply(this, arguments);
            }

            return save;
        }()
    }, {
        key: 'clear',
        value: function () {
            var _ref34 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee34(sd) {
                var _pri70, __;

                return _regenerator2.default.wrap(function _callee34$(_context34) {
                    while (1) {
                        switch (_context34.prev = _context34.next) {
                            case 0:
                                _pri70 = pri(this), __ = _pri70.__;
                                _context34.next = 3;
                                return __.res.clear(sd);

                            case 3:
                            case 'end':
                                return _context34.stop();
                        }
                    }
                }, _callee34, this);
            }));

            function clear(_x41) {
                return _ref34.apply(this, arguments);
            }

            return clear;
        }()
    }]);
    return SecuritySessionSourceDecorator;
}(ASessionSource);
/**
 * NiSessionSource:使用Ni保持和获取会话信息,参数使用key:(sessionID;name)[id,name,value:(any)]
 * sql必须返回values字段作为结果 
 */
var NiSessionSource = exports.NiSessionSource = function (_ASessionSource4) {
    (0, _inherits3.default)(NiSessionSource, _ASessionSource4);

    function NiSessionSource(middler) {
        var appname = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'Ni';
        var templatename = arguments[2];
        var savename = arguments[3];
        var loadname = arguments[4];
        var clearname = arguments[5];
        (0, _classCallCheck3.default)(this, NiSessionSource);

        var _this8 = (0, _possibleConstructorReturn3.default)(this, (NiSessionSource.__proto__ || (0, _getPrototypeOf2.default)(NiSessionSource)).call(this));

        pri(_this8, { middler: middler, appname: appname, templatename: templatename, loadname: loadname, savename: savename, clearname: clearname, ni: new _ni2.default.NiTemplateManager(middler, appname) });
        return _this8;
    }

    (0, _createClass3.default)(NiSessionSource, [{
        key: 'load',
        value: function () {
            var _ref35 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee35(sdm) {
                var id = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
                var name = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';

                var _pri71, _, __, res;

                return _regenerator2.default.wrap(function _callee35$(_context35) {
                    while (1) {
                        switch (_context35.prev = _context35.next) {
                            case 0:
                                _pri71 = pri(this), _ = _pri71._, __ = _pri71.__;
                                _context35.next = 3;
                                return __.ni.excute(__.templatename, __.loadname, { key: (id || '') + ':' + name, id: id, name: name });

                            case 3:
                                res = _context35.sent;

                                if (!res.hasData()) {
                                    _context35.next = 6;
                                    break;
                                }

                                return _context35.abrupt('return', (res.last()[0][0] || res.last()[0]).value || "");

                            case 6:
                                return _context35.abrupt('return', "");

                            case 7:
                            case 'end':
                                return _context35.stop();
                        }
                    }
                }, _callee35, this);
            }));

            function load(_x43) {
                return _ref35.apply(this, arguments);
            }

            return load;
        }()
    }, {
        key: 'save',
        value: function () {
            var _ref36 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee36(sd, data) {
                var _pri72, _, __;

                return _regenerator2.default.wrap(function _callee36$(_context36) {
                    while (1) {
                        switch (_context36.prev = _context36.next) {
                            case 0:
                                _pri72 = pri(this), _ = _pri72._, __ = _pri72.__;
                                _context36.next = 3;
                                return __.ni.excute(__.templatename, __.savename, { key: sd.SessionID + ':' + sd.Name, id: sd.SessionID || '', name: sd.Name || '', value: _querystring2.default.stringify(data) });

                            case 3:
                                return _context36.abrupt('return', "");

                            case 4:
                            case 'end':
                                return _context36.stop();
                        }
                    }
                }, _callee36, this);
            }));

            function save(_x46, _x47) {
                return _ref36.apply(this, arguments);
            }

            return save;
        }()
    }, {
        key: 'clear',
        value: function () {
            var _ref37 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee37(sd) {
                var _pri73, _, __, data;

                return _regenerator2.default.wrap(function _callee37$(_context37) {
                    while (1) {
                        switch (_context37.prev = _context37.next) {
                            case 0:
                                _pri73 = pri(this), _ = _pri73._, __ = _pri73.__;
                                data = sd.serialize();
                                _context37.next = 4;
                                return __.ni.excute(__.templatename, __.clearname, { key: sd.SessionID + ':' + sd.Name, id: sd.SessionID || '', name: sd.Name || '', value: _querystring2.default.stringify(data) });

                            case 4:
                                return _context37.abrupt('return', "");

                            case 5:
                            case 'end':
                                return _context37.stop();
                        }
                    }
                }, _callee37, this);
            }));

            function clear(_x48) {
                return _ref37.apply(this, arguments);
            }

            return clear;
        }()
    }]);
    return NiSessionSource;
}(ASessionSource);
/**
 * 仅用于一次请求处理期间的数据保持，无法存留
 */
var NoStoreSessionSource = exports.NoStoreSessionSource = function (_ASessionSource5) {
    (0, _inherits3.default)(NoStoreSessionSource, _ASessionSource5);

    function NoStoreSessionSource() {
        (0, _classCallCheck3.default)(this, NoStoreSessionSource);
        return (0, _possibleConstructorReturn3.default)(this, (NoStoreSessionSource.__proto__ || (0, _getPrototypeOf2.default)(NoStoreSessionSource)).call(this));
    }

    return NoStoreSessionSource;
}(ASessionSource);
var SessionDataAdapter = exports.SessionDataAdapter = function () {
    function SessionDataAdapter(res) {
        (0, _classCallCheck3.default)(this, SessionDataAdapter);

        pri(this, { res: res, idic: {} });
        if (!res) throw new Error('默认数据源不能为空!');
    }

    (0, _createClass3.default)(SessionDataAdapter, [{
        key: 'setResource',
        value: function setResource(k, res) {
            var _pri74 = pri(this),
                _ = _pri74._,
                __ = _pri74.__;

            __.idic[k] = res;
        }
    }, {
        key: 'getResource',
        value: function getResource(k) {
            var _pri75 = pri(this),
                _ = _pri75._,
                __ = _pri75.__;

            return __.idic[k] ? __.idic[k] : __.res;
        }
    }, {
        key: 'fillSessionData',
        value: function () {
            var _ref38 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee38(data) {
                var source, text;
                return _regenerator2.default.wrap(function _callee38$(_context38) {
                    while (1) {
                        switch (_context38.prev = _context38.next) {
                            case 0:
                                if (!(data && data.Name)) {
                                    _context38.next = 9;
                                    break;
                                }

                                source = this.getResource(data.Name);
                                _context38.next = 4;
                                return source.load(data.Manager, data.SessionID, data.Name);

                            case 4:
                                text = _context38.sent;

                                if (text) {
                                    data.deserialize(text, true);
                                }
                                return _context38.abrupt('return', data);

                            case 9:
                                throw new Error('必须拥有name值');

                            case 10:
                            case 'end':
                                return _context38.stop();
                        }
                    }
                }, _callee38, this);
            }));

            function fillSessionData(_x49) {
                return _ref38.apply(this, arguments);
            }

            return fillSessionData;
        }()
    }, {
        key: 'getSessionData',
        value: function () {
            var _ref39 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee39(manager, id, name) {
                var sessionData;
                return _regenerator2.default.wrap(function _callee39$(_context39) {
                    while (1) {
                        switch (_context39.prev = _context39.next) {
                            case 0:
                                sessionData = new SessionData(id, name);

                                sessionData.Manager = manager;
                                _context39.next = 4;
                                return this.fillSessionData(sessionData);

                            case 4:
                                return _context39.abrupt('return', _context39.sent);

                            case 5:
                            case 'end':
                                return _context39.stop();
                        }
                    }
                }, _callee39, this);
            }));

            function getSessionData(_x50, _x51, _x52) {
                return _ref39.apply(this, arguments);
            }

            return getSessionData;
        }()
    }, {
        key: 'saveSessionData',
        value: function () {
            var _ref40 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee40(data) {
                var source;
                return _regenerator2.default.wrap(function _callee40$(_context40) {
                    while (1) {
                        switch (_context40.prev = _context40.next) {
                            case 0:
                                if (!(data && data.Name)) {
                                    _context40.next = 6;
                                    break;
                                }

                                source = this.getResource(data.Name);
                                _context40.next = 4;
                                return source.save(data, data.serialize());

                            case 4:
                                _context40.next = 7;
                                break;

                            case 6:
                                throw new Error('必须拥有name值');

                            case 7:
                            case 'end':
                                return _context40.stop();
                        }
                    }
                }, _callee40, this);
            }));

            function saveSessionData(_x53) {
                return _ref40.apply(this, arguments);
            }

            return saveSessionData;
        }()
    }, {
        key: 'clearSessionData',
        value: function () {
            var _ref41 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee41(data) {
                var source;
                return _regenerator2.default.wrap(function _callee41$(_context41) {
                    while (1) {
                        switch (_context41.prev = _context41.next) {
                            case 0:
                                if (!(data && data.Name)) {
                                    _context41.next = 6;
                                    break;
                                }

                                source = this.getResource(data.Name);
                                _context41.next = 4;
                                return source.clear(data);

                            case 4:
                                _context41.next = 7;
                                break;

                            case 6:
                                throw new Error('必须拥有name值');

                            case 7:
                            case 'end':
                                return _context41.stop();
                        }
                    }
                }, _callee41, this);
            }));

            function clearSessionData(_x54) {
                return _ref41.apply(this, arguments);
            }

            return clearSessionData;
        }()
    }]);
    return SessionDataAdapter;
}();
exports.default = { SessionData: SessionData, User: User, CreateID: CreateID, SessionDataManagerFactory: SessionDataManagerFactory, SessionDataManager: SessionDataManager, SessionDataAdapter: SessionDataAdapter, ASessionSource: ASessionSource, ConstSessionSource: ConstSessionSource, CookieSessionSource: CookieSessionSource, SecuritySessionSourceDecorator: SecuritySessionSourceDecorator, NiSessionSource: NiSessionSource, NoStoreSessionSource: NoStoreSessionSource };

var pri = _gcl2.default.pris();
//# sourceMappingURL=session.js.map